//Aerial Perspective Macro UI written by Nicholas Warren March 2004
//All of the following code is my own work
//This file is to be placed in the shake/include/startup/UI folder

//The follwing block tells shake to put the macro in the layer tab, to look for the icon and
//the image parameters for the node

nuiPushToolBox("Layer"); 
	nuiToolBoxItem("AerialPerspective", AerialPerspective(0,0,0,0,0,0,0)); 
nuiPopToolBox(); 

//The following block tells shake to group all of the image inputs under a group called image
//inputs. This will fold them away neatly in the interface.

nuiPushControlGroup("Image Inputs");
   	nuiGroupControl("AerialPerspective.input1");
   	nuiGroupControl("AerialPerspective.input2");
    	nuiGroupControl("AerialPerspective.input3");
    	nuiGroupControl("AerialPerspective.input4");
   	nuiGroupControl("AerialPerspective.input5");
   	nuiGroupControl("AerialPerspective.input6");
   	nuiGroupControl("AerialPerspective.input7");
nuiPopControlGroup();

//The following declarations tell shake what kind of interface element to use with each variable

//These declarations tell shake to use a slider set between the specified ranges and using the
//specified hard and soft snaps

nuiDefSlider("AerialPerspective.sunDirection", 0,180,1);
nuiDefSlider("AerialPerspective.particleDensity", 0,1,0.001,0.01);
nuiDefSlider("AerialPerspective.cloudDensity", 0,1,0.001,0.01);
nuiDefSlider("AerialPerspective.degree", 1,3,1);
nuiDefSlider("AerialPerspective.satValue", 0,1,0.0001,0.01);
nuiDefSlider("AerialPerspective.defocusValue", 0,50,0.001,1);

//These delarations tell shake to use a toggle for these variables. The togle is either 0 or 1

nuxDefExprToggle("AerialPerspective.premult1");
nuxDefExprToggle("AerialPerspective.premult2");
nuxDefExprToggle("AerialPerspective.premult3");
nuxDefExprToggle("AerialPerspective.premult4");
nuxDefExprToggle("AerialPerspective.premult5");
nuxDefExprToggle("AerialPerspective.premult6");

//The following blocks all define groups for which the variables will be tucked away into

//Put the following RGB values into a colour picker called Sky low

nuiPushControlGroup("Sky Low");
   	 nuiGroupControl("AerialPerspective.red");
   	 nuiGroupControl("AerialPerspective.green");
   	 nuiGroupControl("AerialPerspective.blue");
nuiPopControlGroup();
nuiPushControlWidget("Sky Low",nuiConnectColorTriplet(kRGBToggle,kCurrentColor,1));

//Put the following RGB values into a colour picker called Sky High

nuiPushControlGroup("Sky High");
   	 nuiGroupControl("AerialPerspective.red1");
   	 nuiGroupControl("AerialPerspective.green1");
   	 nuiGroupControl("AerialPerspective.blue1");
nuiPopControlGroup();
nuiPushControlWidget("Sky High",nuiConnectColorTriplet(kRGBToggle,kCurrentColor,1));

//Group the following attributes together. The group is called Layer Depths

nuiPushControlGroup("AerialPerspective.Layer Depths");
 	nuiGroupControl("AerialPerspective.depth1");
	nuiGroupControl("AerialPerspective.depth2");
	nuiGroupControl("AerialPerspective.depth3");
	nuiGroupControl("AerialPerspective.depth4");
	nuiGroupControl("AerialPerspective.depth5");
	nuiGroupControl("AerialPerspective.depth6");
	nuiGroupControl("AerialPerspective.depth7");
//Add a subgroup called Premultiplication Layers to the Layer Depths group
	nuiPushControlGroup("AerialPerspective.Premultiplication Layers");
		nuiGroupControl("AerialPerspective.premult1");
		nuiGroupControl("AerialPerspective.premult2");
		nuiGroupControl("AerialPerspective.premult3");
		nuiGroupControl("AerialPerspective.premult4");
		nuiGroupControl("AerialPerspective.premult5");
		nuiGroupControl("AerialPerspective.premult6");
	nuiPopControlGroup();
nuiPopControlGroup();

//Group the following attributes together. The group is called Distance Parameters

nuiPushControlGroup("AerialPerspective.Distance Parameters");
	nuiGroupControl("AerialPerspective.degree");
	nuiGroupControl("AerialPerspective.satValue");
	nuiGroupControl("AerialPerspective.defocusValue");
	nuiGroupControl("AerialPerspective.shape");
nuiPopControlGroup();

//Group the following attributes together. The group is called Effect Modifiers

nuiPushControlGroup("AerialPerspective.Effect Modifiers");
	nuiGroupControl("AerialPerspective.sunDirection");
	nuiGroupControl("AerialPerspective.particleDensity");
	nuiGroupControl("AerialPerspective.cloudDensity");
nuiPopControlGroup();
